Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::MAC_Filter Class Reference

`#include <filters.h>`

Inheritance diagram for Botan::MAC_Filter:

## Public Member Functions
virtual bool | attachable ()
void | end_msg () override
Key_Length_Specification | key_spec () const override
| MAC_Filter (MessageAuthenticationCode *mac, size_t out_len=0)
| MAC_Filter (MessageAuthenticationCode *mac, const SymmetricKey &key, size_t out_len=0)
| MAC_Filter (const std::string &mac, size_t len=0)
| MAC_Filter (const std::string &mac, const SymmetricKey &key, size_t len=0)
std::string | name () const override
virtual void | set_iv (const InitializationVector &iv)
void | set_key (const SymmetricKey &key) override
virtual void | start_msg ()
virtual bool | valid_iv_length (size_t length) const
bool | valid_keylength (size_t length) const
void | write (const uint8_t input[], size_t len) override

## Protected Member Functions
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)

## Detailed Description

MessageAuthenticationCode Filter.

Definition at line 134 of file filters.h.

## Constructor & Destructor Documentation

Botan::MAC_Filter::MAC_Filter | ( | MessageAuthenticationCode * | mac,
|  | size_t | out_len = `0`
| ) |  |
| inline

Construct a MAC filter. The MAC key will be left empty.

Parameters

  mac | the MAC to use
  out_len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 158 of file filters.h.

159 :
160 m_mac(mac),
161 m_out_len(out_len)
162 {
163 }

Botan::MAC_Filter::MAC_Filter | ( | MessageAuthenticationCode * | mac,
|  | const SymmetricKey & | key,
|  | size_t | out_len = `0`
| ) |  |
| inline

Construct a MAC filter.

Parameters

  mac | the MAC to use
  key | the MAC key to use
  out_len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 174 of file filters.h.

References m_mac.

176 :
177 m_mac(mac),
178 m_out_len(out_len)
179 {
180 m_mac->set_key(key);
181 }

Botan::MAC_Filter::MAC_Filter | ( | const std::string & | mac,
|  | size_t | len = `0`
| ) |  |

Construct a MAC filter. The MAC key will be left empty.

Parameters

  mac | the name of the MAC to use
  len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 66 of file algo_filt.cpp.

66 :
67 m_mac(MessageAuthenticationCode::create_or_throw(mac_name)),
68 m_out_len(len)
69 {
70 }
Botan::MessageAuthenticationCode::create_or_throw
static std::unique_ptr< MessageAuthenticationCode > create_or_throw(const std::string &algo_spec, const std::string &provider="")
Definition: mac.cpp:138

Botan::MAC_Filter::MAC_Filter | ( | const std::string & | mac,
|  | const SymmetricKey & | key,
|  | size_t | len = `0`
| ) |  |

Construct a MAC filter.

Parameters

  mac | the name of the MAC to use
  key | the MAC key to use
  len | the output length of this filter. Leave the default value 0 if you want to use the full output of the MAC. Otherwise, specify a smaller value here so that the output of the MAC will be cut off.

Definition at line 72 of file algo_filt.cpp.

72 :
73 m_mac(MessageAuthenticationCode::create_or_throw(mac_name)),
74 m_out_len(len)
75 {
76 m_mac->set_key(key);
77 }
Botan::MessageAuthenticationCode::create_or_throw
static std::unique_ptr< MessageAuthenticationCode > create_or_throw(const std::string &algo_spec, const std::string &provider="")
Definition: mac.cpp:138

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

void Botan::MAC_Filter::end_msg | ( |  | ) |
| override virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 79 of file algo_filt.cpp.

References Botan::Filter::send().

80 {
81 secure_vector<uint8_t> output = m_mac->final();
82 if(m_out_len)
83 send(output, std::min<size_t>(m_out_len, output.size()));
84 else
85 send(output);
86 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

Key_Length_Specification Botan::MAC_Filter::key_spec | ( |  | ) | const
| inline override virtual

Returns
  object describing limits on key size

Implements Botan::Keyed_Filter.

Definition at line 148 of file filters.h.

References m_mac.

148 { return m_mac->key_spec(); }

std::string Botan::MAC_Filter::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 140 of file filters.h.

References m_mac.

140 { return m_mac->name(); }

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hash_Filter::end_msg(), end_msg(), Botan::StreamCipher_Filter::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Keyed_Filter::set_iv | ( | const InitializationVector & | iv | ) |
| virtual inherited

Set the initialization vector of this filter. Note: you should call set_iv() only after you have called set_key()

Parameters

  iv | the initialization vector to use

Reimplemented in Botan::StreamCipher_Filter, and Botan::Cipher_Mode_Filter.

Definition at line 13 of file basefilt.cpp.

References Botan::OctetString::length(), and Botan::Filter::name().

Referenced by Botan::get_cipher().

14 {
15 if(iv.length() != 0)
16 throw Invalid_IV_Length(name(), iv.length());
17 }
Botan::Filter::name
virtual std::string name() const =0

void Botan::MAC_Filter::set_key | ( | const SymmetricKey & | key | ) |
| inline override virtual

Set the key of this filter.

Parameters

  key | the key to set

Implements Botan::Keyed_Filter.

Definition at line 146 of file filters.h.

References m_mac.

146 { m_mac->set_key(key); }

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 {}

virtual bool Botan::Keyed_Filter::valid_iv_length | ( | size_t | length | ) | const
| inline virtual inherited

Check whether an IV length is valid for this filter

Parameters

  length | the IV length to be checked for validity

Returns
  true if the IV length is valid, false otherwise

Reimplemented in Botan::StreamCipher_Filter, and Botan::Cipher_Mode_Filter.

Definition at line 57 of file key_filt.h.

58 { return (length == 0); }

bool Botan::Keyed_Filter::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a key length is valid for this filter

Parameters

  length | the key length to be checked for validity

Returns
  true if the key length is valid, false otherwise

Definition at line 42 of file key_filt.h.

43 {
44 return key_spec().valid_keylength(length);
45 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Keyed_Filter::key_spec
virtual Key_Length_Specification key_spec() const =0

void Botan::MAC_Filter::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| inline override virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 137 of file filters.h.

References m_mac.

137 { m_mac->update(input, len); }

The documentation for this class was generated from the following files:

- src/lib/filters/filters.h
- src/lib/filters/algo_filt.cpp